Magellan Linux

Diff of /branches/mage-next/src/smage2.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 597 by niro, Mon Nov 5 16:47:10 2007 UTC revision 2209 by niro, Mon Oct 14 11:00:28 2013 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3    
4  # compiles/installs .smage2 source install scripts  # compiles/installs .smage2 source install scripts
5  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
6    
7  # SMAGE2  # TODO: record dynlib, gz | xz database
 # $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.59 2007-11-05 16:47:10 niro Exp $  
8    
 #01.10.2004  
 # added ccache support  
 # added distcc support  
9    
10  # set default user mage.rc  # set default user mage.rc
11  : ${MAGERC="/etc/mage.rc"}  : ${MAGERC="/etc/mage.rc"}
12    
 ## setup ##  
 PKGSUFFIX="mpk"  
 SRCPKGSUFFIX="mpks"  
 SMAGENAME="$1"  
 SMAGESUFFIX="smage2"  
 MLIBDIR=/usr/lib/mage  
 SMAGEVERSION="$( < ${MLIBDIR}/version)"  
   
 ## only for tests -> normally in /etc/rc.d/init.d/functions  
 COLRED="\033[1;6m\033[31m"  
 COLGREEN="\033[1;6m\033[32m"  
 COLYELLOW="\033[1;6m\033[33m"  
 COLBLUE="\033[1;6m\033[34m"  
 COLMAGENTA="\033[1;6m\033[35m"  
 COLWHITE="\033[1;6m\033[37m"  
 COLGRAY="\033[0;6m\033[37m"  
 COLBOLD="\033[1m"  
 COLDEFAULT="\033[0m"  
   
 if [[ ${NOCOLORS} = true ]]  
 then  
  COLRED=""  
  COLGREEN=""  
  COLYELLOW=""  
  COLBLUE=""  
  COLMAGENTA=""  
  COLWHITE=""  
  COLGRAY=""  
  COLBOLD=""  
  COLDEFAULT=""  
 fi  
   
13  # export default C locale  # export default C locale
14  export LC_ALL=C  export LC_ALL=C
15    
16  source /etc/mage.rc.global  source /etc/mage.rc.global
17  source ${MAGERC}  source ${MAGERC}
18    source ${MLIBDIR}/mage4.functions.sh
19    source ${MLIBDIR}/smage2.functions.sh
20    
21    # export default path
22    export PATH="${PATH}:${MLIBDIR}"
23    
24    ## setup ##
25    SMAGENAME="$1"
26    SMAGEVERSION="$(< ${MLIBDIR}/version)"
27    
28  # set PKGDIR and BUILDDIR and BINDIR to MROOT  # expand PKGDIR, BUILDDIR and BINDIR with MROOT
29  if [[ -n ${MROOT} ]]  if [[ -n ${MROOT} ]]
30  then  then
31   export PKGDIR=${MROOT}/${PKGDIR}   export PKGDIR=${MROOT}/${PKGDIR}
# Line 59  then Line 33  then
33   export BINDIR=${MROOT}/${BINDIR}   export BINDIR=${MROOT}/${BINDIR}
34  fi  fi
35    
 showversion()  
 {  
  echo -en "Magellan Source Install v${SMAGEVERSION} "  
  echo -e  "-- Niels Rogalla (niro@magellan-linux.de)"  
 }  
   
 die()  
 {  
  xtitleclean  
  echo -e ${COLRED}"Exited ${BASH_SOURCE} at line no ${BASH_LINENO}."${COLDEFAULT}  
  echo "SMAGE failed: $@"  
  exit 1  
 }  
   
 xtitle()  
 {  
  if [[ ${TERM} = xterm ]]  
  then  
  echo -ne "\033]0;[sMage: $@]\007"  
  fi  
  return 0  
 }  
   
 xtitleclean()  
 {  
  if [[ ${TERM} = xterm ]]  
  then  
  echo -ne "\033]0;\007"  
  fi  
  return 0  
 }  
   
 syncsmage2()  
 {  
  xtitle "Updating smage2-script tree ..."  
  local i  
  for i in ${SMAGE2RSYNC}  
  do  
  rsync ${RSYNC_FETCH_OPTIONS} ${i} ${SMAGESCRIPTSDIR}  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  done  
   
  # clean up backup files (foo~)  
  find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'  
   
  xtitleclean  
 }  
   
 # $1 filename  
 get_db_md5_sum()  
 {  
  local DB_FILE  
  local MD5_FILE  
  local i  
   
  DB_ENTRY="$(basename $1)"  
  MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} ${SMAGESUFFIX})"  
   
  i="$(cat ${MD5_FILE}| grep ${DB_ENTRY} | cut -d' ' -f1)"  
   
  echo "${i}"  
 }  
   
 download_sources()  
 {  
   
  [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0  
   
  local EOA=${#SRC_URI[*]}  
  local my_SRC_URI  
  local my_SRC_URI_DEST  
  local my_SRC_URI_MIRROR  
  local my_SOURCEDIR  
  local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"  
  local FETCHING  
  local i mirror  
   
   
  # install SRCDIR/PNAME if not exist  
  [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}  
   
  # check if FETCHING is needed  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} &> /dev/null )  
  if [[ $? = 0 ]]  
  then  
  # md5's ok, no fetching needed  
  FETCHING=false  
  else  
  FETCHING=true  
  fi  
   
  for ((i=0; i < EOA; i++))  
  do  
  # url to file  
  my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"  
   
  # subdir in sources dir; the my_SRCI_URI file goes to there  
  my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"  
   
  # if my_src_uri_dest is not equal my_src_uri; than an other dir is used  
  if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]  
  then  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}/${my_SRC_URI_DEST}"  
  else  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}"  
  fi  
   
  # if an mirrored file than replace first the mirror uri  
  if [[ -n $(echo ${my_SRC_URI} | grep 'mirror://') ]]  
  then  
  for mirror in ${MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|mirror:/|${mirror}/sources|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'sourceforge://') ]]  
  then  
  for mirror in ${SOURCEFORGE_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|sourceforge:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'gnu://') ]]  
  then  
  for mirror in ${GNU_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|gnu:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'kde://') ]]  
  then  
  for mirror in ${KDE_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|kde:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'gnome://') ]]  
  then  
  for mirror in ${GNOME_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|gnome:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  else  
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI}"  
  fi  
  fi  
   
  # unset them to be shure  
  unset my_SRC_URI  
  unset my_SRC_URI_DEST  
  unset my_SRC_URI_MIRROR  
  unset my_SOURCEDIR  
  done  
   
  # recheck md5 sums  
  echo  
  echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} ) || die "md5 failed"  
  echo  
   
  # not needed anymore  
  unset SRC_URI  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_prepare()  
 {  
  echo "no src_prepare defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_compile()  
 {  
  echo "no src_compile defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_install()  
 {  
  echo "no src_install defined"  
  sleep 2  
  return 0  
 }  
   
 mlibdir()  
 {  
  local libdir=lib  
  [[ ${ARCH} = x86_64 ]] && libdir=lib64  
   
  echo "${libdir}"  
 }  
   
 mconfigure()  
 {  
  if [ -x ./configure ]  
  then  
  ./configure \  
  --prefix=/usr \  
  --host=${CHOST} \  
  --mandir=/usr/share/man \  
  --infodir=/usr/share/info \  
  --datadir=/usr/share \  
  --sysconfdir=/etc \  
  --localstatedir=/var/lib \  
  --libdir=/usr/$(mlibdir) \  
  "$@" || die "mconfigure failed"  
  else  
  echo "configure is not an executable ..."  
  exit 1  
  fi  
 }  
   
 minstall()  
 {  
  if [ -f ./[mM]akefile -o -f ./GNUmakefile ]  
  then  
  make prefix=${BINDIR}/usr \  
  datadir=${BINDIR}/usr/share \  
  infodir=${BINDIR}/usr/share/info \  
  localstatedir=${BINDIR}/var/lib \  
  mandir=${BINDIR}/usr/share/man \  
  sysconfdir=${BINDIR}/etc \  
  libdir=${BINDIR}/usr/$(mlibdir) \  
  "$@" install || die "minstall failed"  
         else  
                 die "no Makefile found"  
         fi  
 }  
   
 mmake()  
 {  
  make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"  
 }  
   
 munpack()  
 {  
  local SRCFILE  
  local IFTAR  
  local DEST  
   
  SRCFILE=$1  
   
  if [[ -z $2 ]]  
  then  
  DEST=${BUILDDIR}  
  else  
  DEST=$2  
  fi  
   
  [[ ! -d ${DEST} ]] && install -d ${DEST}  
   
  case "${SRCFILE##*.}" in  
  bz2)  
  IFTAR="$(basename $SRCFILE .bz2)"  
  IFTAR="${IFTAR##*.}"  
  if [[ ${IFTAR} = tar ]]  
  then  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.bz2 unpack failed."  
  else  
  pushd ${DEST} > /dev/null  
  bzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .bz2) || die ".bz2 unpack failed."  
  popd > /dev/null  
  fi  
  ;;  
  gz)  
  IFTAR="$(basename $SRCFILE .gz)"  
  IFTAR="${IFTAR##*.}"  
  if [[ ${IFTAR} = tar ]]  
  then  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.gz unpack failed."  
  else  
  pushd ${DEST} > /dev/null  
  zcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .gz) || die ".gz unpack failed."  
  popd > /dev/null  
  fi  
  ;;  
  tbz2)  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tbz2 unpack failed."  
  ;;  
  tgz)  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tgz unpack failed."  
  ;;  
  rar)  
  unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST}  || die ".rar unpack failed."  
  ;;  
  zip)  
  unzip ${SOURCEDIR}/${PNAME}/${SRCFILE} -d ${DEST} || die ".zip unpack failed."  
  ;;  
  rpm)  
  pushd ${BUILDDIR} > /dev/null  
  rpm2targz ${SOURCEDIR}/${PNAME}/${SRCFILE} || die "rpm2targz: .rpm unpack failed."  
  tar --no-same-owner -xvzf ${SRCFILE/.rpm/.tar.gz/} || die "tar: .rpm unpack failed."  
  [[ -f ${BUILDDIR}/${SRCFILE/.rpm/.tar.gz/} ]] && rm ${BUILDDIR}/${SRCFILE/.rpm/.tar.gz/}  
  ;;  
  *)  
  die "munpack failed"  
  ;;  
  esac  
 }  
   
 mpatch()  
 {  
  local PATCHOPTS  
  local PATCHFILE  
  local i  
   
  PATCHOPTS=$1  
  PATCHFILE=$2  
   
  if [[ -z $2 ]]  
  then  
  PATCHFILE=$1  
   
  ## patch level auto-detection, get patch level  
  for ((i=0; i < 10; i++))  
  do  
  patch --dry-run -Np${i} -i ${SOURCEDIR}/${PNAME}/${PATCHFILE} > /dev/null  
  if [[ $? = 0 ]]  
  then  
  PATCHOPTS="-Np${i}"  
  break  
  fi  
  done  
  fi  
   
  echo -e "${COLBLUE}*** ${COLGREEN}Applying patch '${PATCHFILE}'${COLDEFAULT}"  
  patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}  
 }  
   
 mlibtoolize()  
 {  
  local opts="$@"  
  [[ -z ${opts} ]] && opts="--copy --force"  
   
  libtoolize ${opts} || die "running: mlibtoolize ${opts}"  
 }  
   
 minstalldocs()  
 {  
  local docfiles  
  docfiles="$@"  
   
  if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]  
  then  
  install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."  
  fi  
   
  for i in ${docfiles}  
  do  
  cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."  
  install -m 0644 ${SRCDIR}/${i}.gz \  
  ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."  
  done  
 }  
   
 mstriplibs()  
 {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 mstripbins()  
 {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 sminclude()  
 {  
  local i  
   
  if [[ -n "$@" ]]  
  then  
  for i in $@  
  do  
  echo "--- Including ${SMAGESCRIPTSDIR}/include/${i}.sminc"  
  source ${SMAGESCRIPTSDIR}/include/${i}.sminc  
  done  
  echo  
  fi  
 }  
   
 setup_distcc_environment()  
 {  
  if [ -x /usr/bin/distcc ]  
  then  
  echo -e "${COLBLUE}---${COLGREEN} Using DistCC for compilation ...${COLDEFAULT}"  
  export PATH=/usr/$(mlibdir)/distcc/bin:${PATH} || die "distcc: could not export new $PATH"  
   
  export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"  
   
  # creating distcc tempdir  
  install -o distcc -g daemon -d ${DISTCC_DIR}  
  chmod 1777 ${DISTCC_DIR}  
  fi  
 }  
   
 setup_ccache_environment()  
 {  
  if [ -x /usr/bin/ccache ]  
  then  
  echo -e "${COLBLUE}---${COLGREEN} Using CCache for compilation ...${COLDEFAULT}"  
  export PATH=/usr/$(mlibdir)/ccache/bin:${PATH} || die "ccache: could not export new $PATH"  
  fi  
 }  
   
   
 # fixes given dependencies to match a MAGE_TARGET  
 # fix_mage_deps -target s/depend # <-- note -target !  
 fix_mage_deps()  
 {  
  local target="$1"  
  local depend="$2"  
  local NDEPEND  
  local sym dep cat pver pname  
   
  # deps and provides are special  
  # they must be fixed to match the target  
   
  # run this only if target and depend is not empty  
  if [ -n "${target}" ] && [ -n "${depend}" ]  
  then  
  # fix DEPEND  
  while read sym dep  
  do  
  # ignore empty lines  
  [[ -z ${dep} ]] && continue  
   
  cat="$(dirname ${dep})"  
  # change if not virtual  
  if [[ ${cat} = virtual ]]  
  then  
  pname="$(basename ${dep})"  
  else  
  # fix pver to target-pver  
  # to get pname-target-pver  
   
  # doing it backwards !  
  pver="${dep##*-}"  
  # full pver  
  pname="$(basename ${dep/-${pver}/})${target}-${pver}"  
  fi  
   
  # do not add empty lines  
  if [ -z "${NDEPEND}" ]  
  then  
  NDEPEND="${sym} ${cat}/${pname}"  
  else  
  NDEPEND="${NDEPEND}  
  ${sym} ${cat}/${pname}"  
  fi  
   
  unset cat pname pver  
  done << EOF  
 ${depend}  
 EOF  
  # set NDEPEND to DEPEND  
  depend="${NDEPEND}"  
  fi  
   
  echo "${depend}"  
 }  
   
 # build_mage_script(): helper functions for regen_mage_tree()  
 # generates an mage file with given information in smage file  
 # needs at least:  
 #   PNAME                 name of pkg  
 #   PVER                  version  
 #   PBUILD                revision  
 #   PCATEGORIE            categorie of the pkg  
 #   STATE                 state of pkg stable|unstable|old  
 #   DESCRIPTION           va short description (opt)  
 #   HOMEPAGE              homepage (opt)  
 #   DEPEND                runtime dependencies (opt)  
 #   SDEPEND               add. needed deps to build the pkg (opt)  
 #   PROVIDE               provides a virtual (opt)  
 #  
 # special tags:  
 #   PKGTYPE               type of pkg  
 #   INHERITS              which functions get included  
 #   SPECIAL_FUNCTIONS     special functions wich should also be added  
 #                         warning: they get killed before the build starts !  
 #  
 #   MAGE_TREE_DEST        target destination of the generated tree  
 #   REGEN_MAGE_TREE       set to 'true' to enable this  
 #  
 # gets called with build_mage_script target  
 build_mage_script()  
 {  
  local magefile  
  local dest  
  local target  
  local sym  
  local depname  
   
  # if MAGE_TREE_DEST not set use BUILDDIR  
  : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}  
   
  # determinate which suffix this mage file should get, if any  
  [ -n "$1" ] && target="-$1"  
   
  # name of magefile  
  magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"  
   
  # destination to magefile  
  dest="${MAGE_TREE_DEST}/${PCATEGORIE}/${PNAME}${target}/${magefile}"  
   
  # show what we are doing  
  echo -e "${COLBLUE}===${COLGREEN} generating mage file:${COLDEFAULT}"  
  echo "${dest}"  
   
  install -d "$(dirname ${dest})"  
  # now build the mage file  
  > ${dest}  
   
  # header  
  echo '# $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.59 2007-11-05 16:47:10 niro Exp $' >> ${dest}  
  echo  >> ${dest}  
   
  # pgkname and state  
  echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}  
  echo "STATE=\"${STATE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # description and homepage  
  echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}  
  echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # special tags and vars  
  echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}  
   
  # echo MAGE_TARGETS ## note -target is needed !  
  echo "MAGE_TARGETS=\"${target}\"" >> ${dest}  
  echo >> ${dest}  
   
  # add special vars  
  if [ -n "${SPECIAL_VARS}" ]  
  then  
  local i  
  for i in ${SPECIAL_VARS}  
  do  
  # being tricky here :)  
  echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}  
  done  
  echo  >> ${dest}  
  fi  
   
  # add at least all includes  
  if [ -n "${INHERITS}" ]  
  then  
  echo -n "minclude"  >> ${dest}  
  local i  
  for i in ${INHERITS}  
  do  
  echo -n " ${i}"  >> ${dest}  
  done  
  echo  >> ${dest}  
  fi  
  echo >> ${dest}  
   
  # deps and provides  
  echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}  
  echo >> ${dest}  
  echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}  
  echo >> ${dest}  
  echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # add special functions  
  if [ -n "${SPECIAL_FUNCTIONS}" ]  
  then  
  local i  
  for i in ${SPECIAL_FUNCTIONS}  
  do  
  # add to mage (quotes needed !)  
  typeset -f "${i}" >> ${dest}  
  echo >> ${dest}  
  # unset to be safe (quotes needed !)  
  #unset "${i}" <-- later to get every target built  
  done  
  echo  >> ${dest}  
  fi  
   
  # pre|post-install|removes  
  typeset -f preinstall >> ${dest}  
  echo  >> ${dest}  
  typeset -f postinstall >> ${dest}  
  echo  >> ${dest}  
  typeset -f preremove >> ${dest}  
  echo  >> ${dest}  
  typeset -f postremove >> ${dest}  
  echo  >> ${dest}  
 }  
   
 regen_mage_tree()  
 {  
  local i  
   
  # build them only if requested  
  if [[ ${REGEN_MAGE_TREE} = true ]]  
  then  
  # run it without targets  
  if [ -z "${MAGE_TARGETS}" ]  
  then  
  echo  
  build_mage_script  
  echo  
  else  
   
  # build for each target an mage file  
  # run it with several targets  
  for i in ${MAGE_TARGETS}  
  do  
  echo  
  build_mage_script "${i}"  
  echo  
  done  
  fi  
  fi  
   
  # now unset all uneeded vars to be safe  
  # unset PKGNAME <-- don't do that; smage needs this var  
  # unset to be safe (quotes needed !)  
 # for i in ${SPECIAL_FUNCTIONS}  
 # do  
 # unset "${i}"  
 # done  
  unset SPECIAL_FUNCTIONS  
 # for i in ${SPECIAL_VARS}  
 # do  
 # unset "${i}"  
 # done  
  unset SPECIAL_VARS  
  unset STATE  
  unset DESCRIPTION  
  unset HOMEPAGE  
  unset PKGTYPE  
  unset INHERITS  
  unset DEPEND  
  unset SDEPEND  
  unset PROVIDE  
  unset preinstall  
  unset postinstall  
  unset preremove  
  unset postremove  
 }  
   
 export_inherits()  
 {  
  local include="$1"  
  shift  
   
  while [ "$1" ]  
  do  
  local functions="$1"  
   
  # sanity checks  
  [ -z "${include}" ] && die "export_inherits(): \$include not given."  
  [ -z "${functions}" ] && die "export_inherits(): \$functions not given."  
   
  eval "${functions}() { ${include}_${functions} ; }"  
   
  # debug  
  [[ ${MAGEDEBUG} = on ]] && typeset -f "${functions}"  
   
  shift  
  done  
 }  
   
 generate_package_md5sum()  
 {  
  local dest  
  local pcat  
  local pname  
  local pver  
  local pbuild  
  local parch  
  local target  
  local pkgname  
   
  # very basic getops  
  for i in $*  
  do  
  case $1 in  
  --pcat|-c) shift; pcat="$1" ;;  
  --pname|-n) shift; pname="$1" ;;  
  --pver|-v) shift; pver="$1" ;;  
  --pbuild|-b) shift; pbuild="$1" ;;  
  --parch|a) shift; parch="$1" ;;  
  --target|t) shift; target="$1" ;;  
  esac  
  shift  
  done  
   
  # sanity checks; abort if not given  
  [ -z "${pcat}" ] && die "generate_package_md5sum() \$pcat not given."  
  [ -z "${pname}" ] && die "generate_package_md5sum() \$pname not given."  
  [ -z "${pver}" ] && die "generate_package_md5sum() \$pver not given."  
  [ -z "${pbuild}" ] && die "generate_package_md5sum() \$pbuild not given."  
  [ -z "${parch}" ] && die "generate_package_md5sum() \$parch not given."  
   
  # check needed global vars  
  [ -z "${PKGDIR}" ] && die "generate_package_md5sum() \$PKGDIR not set."  
  [ -z "${PKGSUFFIX}" ] && die "generate_package_md5sum() \$PKGSUFFIX not set."  
   
  # fix target as it may be empty !  
  [ -n "${target}" ] && target="-${target}"  
   
  # build pkgname  
  pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"  
   
  # build pkg-md5-sum only if requested  
  if [[ ${REGEN_MAGE_TREE} = true ]]  
  then  
  echo -ne "${COLBLUE}===${COLGREEN} generating md5's for ${pkgname}.${PKGSUFFIX} ... ${COLDEFAULT}"  
   
  # abort if not exist  
  if [ ! -f ${PKGDIR}/${pkgname}.${PKGSUFFIX} ]  
  then  
  echo -e "${COLRED}! exists${COLDEFAULT}"  
  return 0  
  fi  
   
  # if MAGE_TREE_DEST not set use BUILDDIR  
  : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}  
   
  # setup md5 dir  
  dest="${MAGE_TREE_DEST}/${pcat}/${pname}/md5"  
  install -d ${dest}  
   
  # gen md5sum  
  ( cd ${PKGDIR}; md5sum "${pkgname}.${PKGSUFFIX}" ) \  
  > ${dest}/${pkgname}.md5  
  echo -e "${COLGREEN}done${COLDEFAULT}"  
  fi  
 }  
   
 source_pkg_build()  
 {  
  if [[ ${PKGTYPE} = virtual ]]  
  then  
  echo "Virtual package detected; src-pkg-tarball not necessary ..."  
  return 0  
  fi  
   
  if [[ ! -d ${SOURCEDIR}/${PNAME} ]]  
  then  
  echo "No SRC_URI defined; src-pkg-tarball not necessary ..."  
  return 0  
  fi  
   
  [ -z "${SRCPKGDIR}" ] && die "\$SRCPKGDIR not found. Please setup your ${MAGERC} correctly."  
   
  echo -e "${COLGREEN}Creating source package tarball ... ${COLDEFAULT}"  
   
  # include the smage2 file  
  cp ${SMAGENAME} ${SOURCEDIR}/${PNAME}  
   
  ( cd ${SOURCEDIR}; tar cvjf ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${PNAME}; )  
  [[ ! -d ${SRCPKGDIR} ]] && install -d ${SRCPKGDIR}  
  mv ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${SRCPKGDIR}/${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX}  
   
  echo -e "${COLGREEN}Source package ${COLBLUE}${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX} ${COLGREEN}successfully builded.${COLDEFAULT}"  
 }  
   
   
36  # print out our version  # print out our version
37  showversion  showversion
38  echo  echo
39    
40  if [ -z "$1" ]  if [[ -z ${SMAGENAME} ]]
41  then  then
42   echo "No .smage2 file given. Exiting."   echo "No .smage2 file given. Exiting."
43   echo   echo
44   exit 1   exit 1
45  fi  fi
46    
47    # load supported mage features
48    load_mage_features
49    
50  # updating smage2-scripts  # updating smage2-scripts
51  if [[ $1 = update ]]  if [[ $1 = update ]]
52  then  then
# Line 959  fi Line 61  fi
61  # creates md5sums for smages to given dir  # creates md5sums for smages to given dir
62  if [[ $1 = calcmd5 ]]  if [[ $1 = calcmd5 ]]
63  then  then
64   if [ $# -ge 3 ]   if [ $# -ge 2 ]
65   then   then
66   SMAGENAME="$2"   SMAGENAME="$2"
67   MD5DIR="$3"   MD5DIR="$3"
68   source ${SMAGENAME} || die "download source failed"   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
69    
70     smagesource ${SMAGENAME} || die "download source failed"
71    
72   # overridable sourcedir; must be declared after source of the smage2   # overridable sourcedir; must be declared after source of the smage2
73   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
# Line 1015  then Line 119  then
119   echo   echo
120   else   else
121   echo "Usage: Calculating MD5 Sums:"   echo "Usage: Calculating MD5 Sums:"
122   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME /path/to/MD5DIR"   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
123   echo   echo
124   echo   echo
125   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
# Line 1037  then Line 141  then
141   # get smage   # get smage
142   SMAGENAME="$2"   SMAGENAME="$2"
143   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
144   source ${SMAGENAME} || die "download source failed"   smagesource ${SMAGENAME} || die "download source failed"
145    
146   download_sources   download_sources
147   exit 0   exit 0
# Line 1049  then Line 153  then
153   # set correct SMAGENAME   # set correct SMAGENAME
154   SMAGENAME="$2"   SMAGENAME="$2"
155   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
156   source ${SMAGENAME} || die "regen: smage2 not found"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
157    
158   regen_mage_tree   regen_mage_tree
159    
160   # build md5sum for existing packages   # build several targets
161   generate_package_md5sum \   if [[ -n ${MAGE_TARGETS} ]]
162   --pcat "${PCATEGORIE}" \   then
163   --pname "${PNAME}" \   for target in ${MAGE_TARGETS}
164   --pver "${PVER}" \   do
165   --pbuild "${PBUILD}" \   # build md5sum for existing packages
166   --parch "${ARCH}" \   generate_package_md5sum \
167   --target "${target}"   --pcat "${PCAT}" \
168     --pname "${PNAME}" \
169     --pver "${PVER}" \
170     --pbuild "${PBUILD}" \
171     --parch "${ARCH}" \
172     --target "${target}"
173     done
174    
175     # build several subpackages
176     elif [[ -n ${SPLIT_PACKAGES} ]]
177     then
178     split_save_variables
179     for subpackage in ${SPLIT_PACKAGES}
180     do
181     # get the right variables for the split
182     export PNAME="${subpackage}"
183     split_info_${subpackage}
184     # fix PCATEGORIE -> PCAT
185     if [[ ! -z ${PCATEGORIE} ]]
186     then
187     PCAT="${PCATEGORIE}"
188     unset PCATEGORIE
189     fi
190     # build md5sum for existing packages
191     generate_package_md5sum \
192     --pcat "${PCAT}" \
193     --pname "${PNAME}" \
194     --pver "${PVER}" \
195     --pbuild "${PBUILD}" \
196     --parch "${ARCH}"
197     # restore smage environment
198     split_restore_variables
199     done
200     # unset all saved smage variables
201     split_unset_variables
202    
203     else
204     # build md5sum for existing packages
205     generate_package_md5sum \
206     --pcat "${PCAT}" \
207     --pname "${PNAME}" \
208     --pver "${PVER}" \
209     --pbuild "${PBUILD}" \
210     --parch "${ARCH}"
211     fi
212    
213   exit 0   exit 0
214  fi  fi
# Line 1073  then Line 221  then
221    
222   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
223    
224   source ${SMAGENAME} || die "regen: smage2 not found"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
225    
226   if [[ -d ${SOURCEDIR}/${PNAME} ]]   if [[ -d ${SOURCEDIR}/${PNAME} ]]
227   then   then
# Line 1089  fi Line 237  fi
237  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
238  then  then
239   SRCPKGTARBALL="${2}"   SRCPKGTARBALL="${2}"
240   USE_SRC_PKG_TARBALL=true   msetfeature "srcpkgtarball"
241    
242   # abort if given file is not a source pkg   # abort if given file is not a source pkg
243   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
# Line 1110  then Line 258  then
258   [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"   [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
259  fi  fi
260    
261    if [ "$1" == "--resume" -a -n "$2" ]
262    then
263     msetfeature "resume"
264     SMAGENAME="$2"
265    fi
266    
267  [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."  [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."
268  [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&  [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
# Line 1122  fi Line 275  fi
275  [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"  [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
276  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
277    
278  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
279  PKGNAME="${PNAME}-${PVER}-${ARCH}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}"
280  MD5DIR="$(dirname ${SMAGENAME})/md5"  MD5DIR="$(dirname ${SMAGENAME})/md5"
281    SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"
282    
283  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
284  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
# Line 1132  echo -e "${COLGREEN}Compiling ${PKGNAME} Line 286  echo -e "${COLGREEN}Compiling ${PKGNAME}
286  # auto regen mage tree if requested  # auto regen mage tree if requested
287  regen_mage_tree  regen_mage_tree
288    
289  if [[ ${CREATE_SRC_PKG_TARBALL} = true ]]  if mqueryfeature "srcpkgbuild"
290  then  then
291   if [[ -d ${SOURCEDIR}/${PNAME} ]]   if [[ -d ${SOURCEDIR}/${PNAME} ]]
292   then   then
# Line 1142  then Line 296  then
296  fi  fi
297    
298  # download sources  # download sources
299  [[ ${USE_SRC_PKG_TARBALL} != true ]] && download_sources  mqueryfeature "srcpkgtarball" || download_sources
300    
301  # fixes some issues with these functions  # fixes some issues with these functions
302  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
303  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
304    export -f src_check || die "src_check export failed"
305  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
306    
307  # fixes some compile issues  # fixes some compile issues
308  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
309  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
310  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  if [[ -z ${CXXFLAGS} ]]
311    then
312     export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
313    else
314     export CXXFLAGS="${CXXFLAGS}" || die "CXXFLAGS export failed"
315    fi
316    export LDFLAGS="${LDFLAGS}" || die "LDFLAGS export failed"
317  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
318  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
319    
   
320  # setup distcc  # setup distcc
321  # setup for distcc goes *before* ccache, so ccache comes before distcc in path  # setup for distcc goes *before* ccache, so ccache comes before distcc in path
322  [[ ${SMAGE_USE_DISTCC} = true ]] && setup_distcc_environment  mqueryfeature "distcc" && setup_distcc_environment
323    
324  # setup ccache  # setup icecc
325  [[ ${SMAGE_USE_CCACHE} = true ]] && setup_ccache_environment  # setup for icecc goes *before* ccache, so ccache comes before icecc in path
326    mqueryfeature "icecc" && setup_icecc_environment
327    
328  # small sleep to show our settings  # setup ccache
329  sleep 1  mqueryfeature "ccache" && setup_ccache_environment
330    
331  # cleans up build if a previously one exists  if mqueryfeature "resume"
 if [ -d ${BUILDDIR} ]  
332  then  then
333   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   echo -e "${COLMAGENTA}Resume requested; continuing previous build${COLDEFAULT}"
334    
335     # setup build logging
336     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
337     if [[ -f /var/log/smage/${PKGNAME}.log.bz2 ]]
338     then
339     bunzip2 -f /var/log/smage/${PKGNAME}.log.bz2
340     fi
341     echo -e "### Resume started on $(date) ###\n" >> /var/log/smage/${PKGNAME}.log
342    
343    else
344     # clean up builddir if a previously one exist
345     if [ -d ${BUILDDIR} ]
346     then
347     rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
348     fi
349     install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
350    
351     # clean up srcdir if a previously unpacked one exist
352     if [ -d ${SRCDIR} ]
353     then
354     rm -rf ${SRCDIR}
355     fi
356    
357     # clean up bindir if a previous build exist or create a new one
358     if [ -d ${BINDIR} ]
359     then
360     rm -rf ${BINDIR}
361     fi
362     install -d ${BINDIR} || die "couldn't create \$BINDIR."
363    
364     # clean up package temp dir if a previous build exist
365     if [ -d ${BUILDDIR}/${PKGNAME} ]
366     then
367     rm -rf ${BUILDDIR}/${PKGNAME}
368     fi
369    
370     # clean up stamps dir
371     if [ -d ${BUILDDIR}/.stamps ]
372     then
373     rm -rf ${BUILDDIR}/.stamps
374     fi
375    
376     # setup build logging
377     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
378     echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
379  fi  fi
 install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  
380    
381  # cleans up srcdir if a previously unpacked one exists  if [[ ${PKGTYPE} = virtual ]]
 if [ -d ${SRCDIR} ]  
382  then  then
383   rm -rf ${SRCDIR}   echo "virtual package detected; nothing will be build ..."
384     # automatically set !pkgbuild here too
385     msetfeature "!pkgbuild"
386    else
387     ( run_resume src_prepare || src_prepare ) | ${SMAGE_LOG_CMD}
388     die_pipestatus 0 "src_prepare failed"
389     resume_stamp src_prepare
390     step_by_step src_prepare
391    
392     ( run_resume src_compile || src_compile ) | ${SMAGE_LOG_CMD}
393     die_pipestatus 0 "src_compile failed"
394     resume_stamp src_compile
395     step_by_step src_compile
396    
397     # only run checks if requested
398     if mqueryfeature "!check"
399     then
400     echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
401     else
402     ( run_resume src_check || src_check ) | ${SMAGE_LOG_CMD}
403     die_pipestatus 0 "src_check failed"
404     resume_stamp src_check
405     fi
406     step_by_step src_check
407    
408     # build several subpackages
409     if [[ -n ${SPLIT_PACKAGES} ]]
410     then
411     # save bindir & pname
412     split_save_variables
413     export SAVED_BINDIR="${BINDIR}"
414     for subpackage in ${SPLIT_PACKAGES}
415     do
416     split_info_${subpackage}
417     if [[ ${PKGTYPE} = virtual ]]
418     then
419     echo
420     echo -en "${COLBLUE}*** ${COLDEFAULT}"
421     echo -en "Virtual package detected"
422     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
423     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
424    
425     echo "virtual package detected; nothing will be build ..."
426     # automatically set !pkgbuild here too
427     msetfeature "!pkgbuild"
428     else
429     if typeset -f src_install_${subpackage} > /dev/null
430     then
431     # export subpackage bindir
432     export BINDIR="${SAVED_BINDIR}_${subpackage}"
433     # export PNAME, several internal function and include
434     # rely on this variable
435     export PNAME="${subpackage}"
436    
437     echo
438     echo -en "${COLBLUE}*** ${COLDEFAULT}"
439     echo -en "Running ${COLGREEN}split src_install()${COLDEFAULT}"
440     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
441     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
442    
443     ( run_resume src_install_${subpackage} || src_install_${subpackage} ) | ${SMAGE_LOG_CMD}
444     die_pipestatus 0 "src_install_${subpackage} failed"
445     resume_stamp src_install_${subpackage}
446     step_by_step src_install_${subpackage}
447     fi
448     fi
449     # restore smage environment
450     split_restore_variables
451     done
452     # unset all saved smage variables
453     split_unset_variables
454     else
455     ( run_resume src_install || src_install ) | ${SMAGE_LOG_CMD}
456     die_pipestatus 0 "src_install failed"
457     resume_stamp src_install
458     step_by_step src_install
459     fi
460  fi  fi
461    
462  # cleans up bindir if a previous build exists or creates a new one  # echo for sake of good-looking
463  if [ -d ${BINDIR} ]  echo
464    
465    if mqueryfeature "!compressdoc"
466    then
467     echo -e "!compressdoc detected; documentation will not be compressed ..."
468    elif mqueryfeature "!pkgbuild"
469  then  then
470   rm -rf ${BINDIR}   echo "!pkgbuild detected; skipping documentation compression..."
471    else
472     # compressing doc, info & man files
473     if [[ -n ${SPLIT_PACKAGES} ]]
474     then
475     # save smage environment
476     split_save_variables
477     for subpackage in ${SPLIT_PACKAGES}
478     do
479     # honor split_info
480     split_info_${subpackage}
481     if [[ ${PKGTYPE} = virtual ]]
482     then
483     # automatically set !pkgbuild here too
484     msetfeature "!pkgbuild"
485     fi
486    
487     if mqueryfeature "!compressdoc"
488     then
489     echo -e "!compressdoc detected; documentation of '${subpackage}' will not be compressed ..."
490     elif mqueryfeature "!pkgbuild"
491     then
492     echo "!pkgbuild detected; skipping documentation compression for '${subpackage}' ..."
493     else
494     run_resume post-mcompressdoc_${subpackage} || mcompressdocs ${BINDIR}_${subpackage}
495     resume_stamp post-mcompressdoc_${subpackage}
496     fi
497     # restore smage environment
498     split_restore_variables
499     done
500     # unset saved variables
501     split_unset_variables
502     else
503     run_resume post-mcompressdoc || mcompressdocs ${BINDIR}
504     resume_stamp post-mcompressdoc
505     fi
506  fi  fi
 install -d ${BINDIR} || die "couldn't create \$BINDIR."  
507    
508  # cleans up package temp dir if a previous build exists  if mqueryfeature "!libtool"
 if [ -d ${BUILDDIR}/${PKGNAME} ]  
509  then  then
510   rm -rf ${BUILDDIR}/${PKGNAME}   if mqueryfeature "!pkgbuild"
511     then
512     echo "!pkgbuild detected; skipping libtool archive stripping ..."
513     else
514     if [[ -n ${SPLIT_PACKAGES} ]]
515     then
516     # save smage environment
517     split_save_variables
518     for subpackage in ${SPLIT_PACKAGES}
519     do
520     # honor split_info
521     split_info_${subpackage}
522     if [[ ${PKGTYPE} = virtual ]]
523     then
524     # automatically set !pkgbuild here too
525     msetfeature "!pkgbuild"
526     fi
527    
528     if mqueryfeature "!libtool"
529     then
530     if mqueryfeature "!pkgbuild"
531     then
532     echo "!pkgbuild detected; skipping libtool archive stripping for '${subpackage}'..."
533     else
534     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
535     run_resume post-mstriplibtoolarchive_${subpackage} || mstriplibtoolarchive ${BINDIR}_${subpackage}
536     resume_stamp post-mstriplibtoolarchive_${subpackage}
537     fi
538     fi
539    
540     # restore smage environment
541     split_restore_variables
542     done
543     # unset saved variables
544     split_unset_variables
545     else
546     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
547     run_resume post-mstriplibtoolarchive || mstriplibtoolarchive ${BINDIR}
548     resume_stamp post-mstriplibtoolarchive
549     fi
550     fi
551  fi  fi
552    
553  # cleans up timestamp if one exists  if mqueryfeature "purge"
 if [ -f /var/tmp/timestamp ]  
554  then  then
555   mage rmstamp   if mqueryfeature "!pkgbuild"
556  fi   then
557     echo "!pkgbuild detected; skipping file purgation ..."
558     else
559     if [[ -n ${SPLIT_PACKAGES} ]]
560     then
561     # save smage environment
562     split_save_variables
563     for subpackage in ${SPLIT_PACKAGES}
564     do
565     # honor split_info
566     split_info_${subpackage}
567     if [[ ${PKGTYPE} = virtual ]]
568     then
569     # automatically set !pkgbuild here too
570     msetfeature "!pkgbuild"
571     fi
572    
573  src_prepare || die "src_prepare failed"   if mqueryfeature "purge"
574  src_compile || die "src_compile failed"   then
575  src_install || die "src_install failed"   if mqueryfeature "!pkgbuild"
576     then
577     echo "!pkgbuild detected; skipping file purgation for '${subpackage}' ..."
578     else
579     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
580     run_resume post-mpurgetargets_${subpackage} || mpurgetargets ${BINDIR}_${subpackage}
581     resume_stamp post-mpurgetargets_${subpackage}
582     fi
583     fi
584    
585     # restore smage environment
586     split_restore_variables
587     done
588     # unset saved variables
589     split_unset_variables
590     else
591     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
592     run_resume post-mpurgetargets || mpurgetargets ${BINDIR}
593     resume_stamp post-mpurgetargets
594     fi
595     fi
596    fi
597    
598  # compressing doc, info & man files  # stripping all bins and libs
599  if [ -d ${BUILDDIR}/builded/usr/share/man ]  if mqueryfeature "!strip"
600    then
601     echo -e "!strip detected; package will not be stripped ..."
602    elif mqueryfeature "!pkgbuild"
603  then  then
604   echo -e "${COLBLUE}===${COLGREEN} compressing man-pages ...${COLDEFAULT}"   echo "!pkgbuild detected; skipping stripping of the package ..."
605   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man  else
606     if [[ -n ${SPLIT_PACKAGES} ]]
607     then
608     # save smage environment
609     split_save_variables
610     for subpackage in ${SPLIT_PACKAGES}
611     do
612     # honor split_info
613     split_info_${subpackage}
614     if [[ ${PKGTYPE} = virtual ]]
615     then
616     # automatically set !pkgbuild here too
617     msetfeature "!pkgbuild"
618     fi
619    
620     if mqueryfeature "!strip"
621     then
622     echo -e "!strip detected; package '${subpackage}' will not be stripped ..."
623     elif mqueryfeature "!pkgbuild"
624     then
625     echo "!pkgbuild detected; skipping stripping of the package '${subpackage}' ..."
626     else
627     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
628     run_resume post-mstripbins_${subpackage} || mstripbins ${BINDIR}_${subpackage}
629     resume_stamp post-mstripbins_${subpackage}
630     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
631     run_resume post-mstriplibs_${subpackage} || mstriplibs ${BINDIR}_${subpackage}
632     resume_stamp post-mstriplibs_${subpackage}
633     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
634     run_resume post-mstripstatic_${subpackage} || mstripstatic ${BINDIR}_${subpackage}
635     resume_stamp post-mstripstatic_${subpackage}
636     fi
637    
638     # restore smage environment
639     split_restore_variables
640     done
641     # unset saved variables
642     split_unset_variables
643     else
644     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
645     run_resume post-mstripbins || mstripbins ${BINDIR}
646     resume_stamp post-mstripbins
647     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
648     run_resume post-mstriplibs || mstriplibs ${BINDIR}
649     resume_stamp post-mstriplibs
650     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
651     run_resume post-mstripstatic || mstripstatic ${BINDIR}
652     resume_stamp post-mstripstatic
653     fi
654  fi  fi
655    
656  if [ -d ${BUILDDIR}/builded/usr/share/info ]  if mqueryfeature "qalint"
657  then  then
658   echo -e "${COLBLUE}===${COLGREEN} compressing info-pages ...${COLDEFAULT}"   if mqueryfeature "!pkgbuild"
659   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   then
660     echo "!pkgbuild detected; skipping QA lint checks ..."
661     else
662     if [[ -n ${SPLIT_PACKAGES} ]]
663     then
664     # save smage environment
665     split_save_variables
666     for subpackage in ${SPLIT_PACKAGES}
667     do
668     # honor split_info
669     split_info_${subpackage}
670     if [[ ${PKGTYPE} = virtual ]]
671     then
672     # automatically set !pkgbuild here too
673     msetfeature "!pkgbuild"
674     fi
675    
676     if mqueryfeature "qalint"
677     then
678     if mqueryfeature "!pkgbuild"
679     then
680     echo "!pkgbuild detected; skipping QA lint checks for '${subpackage}' ..."
681     else
682     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks for '${subpackage}' ...${COLDEFAULT}"
683     mqalint ${BINDIR}_${subpackage}
684     fi
685     fi
686    
687     # restore smage environment
688     split_restore_variables
689     done
690     # unset saved variables
691     split_unset_variables
692     else
693     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks ...${COLDEFAULT}"
694     mqalint ${BINDIR}
695     fi
696     fi
697  fi  fi
698    
699  # stripping all bins and libs  if mqueryfeature "!pkgbuild"
700  case ${NOSTRIP} in  then
701   true|TRUE|yes|y)   echo -e "!pkgbuild detected; Package will not be build ..."
702   echo -e "NOSTRIP=true detected; Package will not be stripped ..."  else
  ;;  
  *)  
  echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"  
  mstripbins ${BINDIR}  
  echo -e "${COLBLUE}===${COLGREEN} stripping libraries ...${COLDEFAULT}"  
  mstriplibs ${BINDIR}  
  ;;  
 esac  
   
 # the new buildpkg command  
 case ${NOPKGBUILD} in  
  true|TRUE|yes|y)  
  echo -e "NOPGKBUILD=true detected; Package will not be build ..."  
  ;;  
  *)  
703   # build several targets   # build several targets
704   if [ -n "${MAGE_TARGETS}" ]   if [[ -n ${MAGE_TARGETS} ]]
705   then   then
706   for target in ${MAGE_TARGETS}   for target in ${MAGE_TARGETS}
707   do   do
708   # check if an special target_pkgbuild exists   # check if a special target_pkgbuild exists
709   if typeset -f ${target}_pkgbuild > /dev/null   if typeset -f ${target}_pkgbuild > /dev/null
710   then   then
711   # run it   # run it
712   ${target}_pkgbuild   run_resume post-${target}_pkgbuild || ${target}_pkgbuild
713     resume_stamp post-${target}_pkgbuild
714   fi   fi
715   # now create the target package   # now create the target package
716   ${MLIBDIR}/pkgbuild_dir.sh \   run_resume post-pkg_builddir_${target} || ${MLIBDIR}/pkgbuild_dir.sh \
717   "${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD}" \   "${PNAME}-${target}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
718   ${BINDIR} || die "target: ${target} package-build failed"   ${BINDIR} || die "target: ${target} package-build failed"
719     resume_stamp post-pkg_builddir_${target}
720    
721   # build pkg-md5-sum if requested   # build pkg-md5-sum if requested
722   generate_package_md5sum \   run_resume post-md5sum_${target} || generate_package_md5sum \
723   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
724   --pname "${PNAME}" \   --pname "${PNAME}" \
725   --pver "${PVER}" \   --pver "${PVER}" \
726   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
727   --parch "${ARCH}" \   --parch "${ARCH}" \
728   --target "${target}"   --target "${target}"
729     resume_stamp post-md5sum_${target}
730    
731   echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"   echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
732   done   done
733    
734     # build several subpackages
735     elif [[ -n ${SPLIT_PACKAGES} ]]
736     then
737     split_save_variables
738     for subpackage in ${SPLIT_PACKAGES}
739     do
740     # get the right variables for the split
741     export PNAME="${subpackage}"
742     split_info_${PNAME}
743     # fix PCATEGORIE -> PCAT
744     if [[ ! -z ${PCATEGORIE} ]]
745     then
746     PCAT="${PCATEGORIE}"
747     unset PCATEGORIE
748     fi
749     if [[ ${PKGTYPE} = virtual ]]
750     then
751     # automatically set !pkgbuild here too
752     msetfeature "!pkgbuild"
753     fi
754    
755     # jump to next one if !pkgbuild is set in split_info
756     if mqueryfeature "!pkgbuild"
757     then
758     # restore smage environment
759     split_restore_variables
760     continue
761     fi
762    
763     # check if an special subpackage_pkgbuild exists
764     if typeset -f ${PNAME}_pkgbuild > /dev/null
765     then
766     # run it
767     run_resume post-${PNAME}_pkgbuild || ${PNAME}_pkgbuild
768     resume_stamp post-${PNAME}_pkgbuild
769     fi
770     # now create the target package
771     run_resume post-pkg_builddir_${PNAME} || ${MLIBDIR}/pkgbuild_dir.sh \
772     "${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
773     "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
774     resume_stamp post-pkg_builddir_${PNAME}
775    
776     # build pkg-md5-sum if requested
777     run_resume post-md5sum_${PNAME} || generate_package_md5sum \
778     --pcat "${PCAT}" \
779     --pname "${PNAME}" \
780     --pver "${PVER}" \
781     --pbuild "${PBUILD}" \
782     --parch "${ARCH}"
783     resume_stamp post-md5sum_${PNAME}
784    
785     echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
786    
787     # restore smage environment
788     split_restore_variables
789     done
790     # unset all saved smage variables
791     split_unset_variables
792    
793   else   else
794   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"   run_resume post-pkg_builddir || ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"
795     resume_stamp post-pkg_builddir
796    
797   # build pkg-md5-sum if requested   # build pkg-md5-sum if requested
798   generate_package_md5sum \   run_resume post-md5sum || generate_package_md5sum \
799   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
800   --pname "${PNAME}" \   --pname "${PNAME}" \
801   --pver "${PVER}" \   --pver "${PVER}" \
802   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
803   --parch "${ARCH}"   --parch "${ARCH}"
804     resume_stamp post-md5sum
805    
806   echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"   echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
807   fi   fi
808    
809   # build src-pkg-tarball if requested   # build src-pkg-tarball if requested
810   [[ ${CREATE_SRC_PKG_TARBALL} = true ]] && source_pkg_build ${SMAGENAME}   if mqueryfeature "srcpkgbuild"
811   ;;   then
812  esac   run_resume post-srcpkgbuild || source_pkg_build ${SMAGENAME}
813     resume_stamp post-srcpkgbuild
814  # for sure   fi
815  unset NOPKGBUILD  fi
816  unset NOSTRIP  
817    if mqueryfeature "buildlog"
818    then
819     bzip2 -9f /var/log/smage/${PKGNAME}.log
820    else
821     [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
822    fi
823    
824  xtitleclean  xtitleclean

Legend:
Removed from v.597  
changed lines
  Added in v.2209